/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2003/07/26 15:39:38 $ $Revision: 1.4 $ */

#include <gtkhtml/gtkhtml.h>
#include <gtkhtml/gtkhtml-stream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "global.h"
#include "XPM/icon.xpm"
#include "about.h"

#define HELP_BUFF_SIZE 32768

void Destry_About(GtkWidget *widget,gpointer data)
{
  if ((int)data) {
    gtk_widget_hide(help.helpwin);
    help.helpisopen=2;
  } else {
    gtk_widget_hide(help.aboutwin);
    help.aboutisopen=2;
  }
}

void About()
{
  GtkStyle  *style;		/* style for pixmap background */
  GdkPixmap *pixmap;		/* pixmap for pixmap buttons */
  GdkBitmap *mask;		/* pixmap mask */
  GtkWidget *vbox;		/* main vbox */
  GtkWidget *l;			/* labels */
  GtkWidget *button;		/* button */
  GdkColor c;			/* color */

  if (help.aboutisopen==0) {
    help.aboutwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(help.aboutwin), "About");
    gtk_window_set_default_size(GTK_WINDOW(help.aboutwin), 300, 100);
    gtk_widget_realize(help.aboutwin);
    style= gtk_widget_get_style(help.aboutwin);
    pixmap = gdk_pixmap_create_from_xpm_d (help.aboutwin->window, &mask,
		       &style->bg[GTK_STATE_NORMAL],XPMicon);
    gdk_window_set_icon(help.aboutwin->window,NULL,pixmap,mask);
    vbox = gtk_vbox_new(TRUE, 1);	/* create main vbox */
    gtk_container_border_width (GTK_CONTAINER (vbox), 1);
    gtk_container_add (GTK_CONTAINER (help.aboutwin), vbox);
    l=gtk_label_new("About Mozi");
    gtk_box_pack_start(GTK_BOX(vbox),l,TRUE,TRUE,0);
    gtk_widget_show(l);
    l=gtk_label_new("Version: 0.9 alpha");
    gtk_box_pack_start(GTK_BOX(vbox),l,TRUE,TRUE,0);
    gtk_widget_show(l);
    l=gtk_label_new("(C) 2002-2004 Janos Torok, Sandor Fazekas");
    gtk_box_pack_start(GTK_BOX(vbox),l,TRUE,TRUE,0);
    gtk_widget_show(l);
    button=gtk_button_new_with_label(
	  "The Big Red button that doesn't do anything");
    gtk_box_pack_start(GTK_BOX(vbox),button,TRUE,TRUE,0);
    c.red=65535;
    c.green=0;
    c.blue=0;
    gtk_widget_modify_bg(button,GTK_STATE_NORMAL,&c);
    gtk_widget_modify_bg(button,GTK_STATE_ACTIVE,&c);
    gtk_widget_modify_bg(button,GTK_STATE_PRELIGHT,&c);
    gtk_widget_modify_bg(button,GTK_STATE_SELECTED,&c);
    gtk_widget_modify_bg(button,GTK_STATE_INSENSITIVE,&c);
    gtk_widget_show(button);
    button=gtk_button_new_with_label(
	  "I have read through this very instructive About window");
    gtk_box_pack_end(GTK_BOX(vbox),button,TRUE,TRUE,0);
    gtk_widget_show(button);

    gtk_widget_show(vbox);
    gtk_widget_show(help.aboutwin);
    gtk_signal_connect(GTK_OBJECT (help.aboutwin), "delete_event",
			 (GtkSignalFunc) Destry_About, 0);
    gtk_signal_connect(GTK_OBJECT (button), "clicked",
			 (GtkSignalFunc) Destry_About, 0);
    help.aboutisopen=1;
  } else if (help.aboutisopen==2) {
    gtk_widget_show(help.aboutwin);
  }
}

void Help()
{
  GtkWidget *dialog,*label,*ok;

  dialog=gtk_dialog_new();
  ok=gtk_button_new_with_label("Ok");
  gtk_signal_connect_object (GTK_OBJECT (ok), "clicked",
		    GTK_SIGNAL_FUNC(gtk_widget_destroy), dialog);
  gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->action_area),ok);
  label=gtk_entry_new();
  gtk_entry_set_text(GTK_ENTRY(label),
      "http://maxwell.phy.bme.hu/~torok/Mozi/mozidoc.html");
  gtk_editable_set_editable(GTK_EDITABLE(label), FALSE);
  gtk_widget_set_usize(label,350,0);
  gtk_container_add (GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
  label=gtk_label_new("");
  gtk_container_add (GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
  gtk_widget_show_all(dialog);
}
