/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2003/05/16 16:03:45 $ $Revision: 1.3 $ */
/* Eye position handler */
#include <gtk/gtk.h>
#include <stdlib.h>
#include "global.h"

/* prototypes */
void Replot_Objects(int);
void RedrawTex(void);

void FrameOff(GtkWidget *widget,gpointer data)
{
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget),FALSE);
  gtk_widget_hide(GTK_WIDGET(data));
}

void ChangeOrient(GtkWidget *widget,gpointer data)
{
  int a;

  a=(int)data;
  switch (a) {
    case 0:
      gl.phix=atof(gtk_entry_get_text(GTK_ENTRY(widget)));
      break;
    case 1:
      gl.phiy=atof(gtk_entry_get_text(GTK_ENTRY(widget)));
      break;
    case 2:
      gl.phiz=atof(gtk_entry_get_text(GTK_ENTRY(widget)));
      break;
  }
  Replot_Objects(0);
}

void ChangeEye(GtkWidget *widget,gpointer data)
{
  int a;

  a=(int)data;
  switch (a) {
    case 0:
      gl.x=atof(gtk_entry_get_text(GTK_ENTRY(widget)));
      break;
    case 1:
      gl.y=atof(gtk_entry_get_text(GTK_ENTRY(widget)));
      break;
    case 2:
      gl.z=atof(gtk_entry_get_text(GTK_ENTRY(widget)));
      break;
  }
  Replot_Objects(0);
}

/* Eye frame */
void CreateEyeFrameItems(GtkWidget *frame)
{
  GtkWidget *vbox;		/* vbox for a little space */
  GtkWidget *hbox;		/* hbox for eye position */
  GtkWidget *dummy;		/* dummy widget for labels */
  GtkWidget *x,*y,*z;		/* widgets for coordinates */
  GtkWidget *off;		/* switch frame off button */
  char s[14];			/* string for frameskip */

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(frame),vbox);
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,3);
  dummy=gtk_label_new("X:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,5);
  gtk_widget_show(dummy);
  gl.wx=x=gtk_entry_new_with_max_length(10);
  gtk_widget_set_usize(x,50,0);
  sprintf(s,"%.2lf",gl.x);
  gtk_entry_set_text(GTK_ENTRY(x), s);
  gtk_box_pack_start(GTK_BOX(hbox), x, FALSE, FALSE, 5);
  gtk_widget_show(x);
  dummy=gtk_label_new("Y:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,5);
  gtk_widget_show(dummy);
  gl.wy=y=gtk_entry_new_with_max_length(10);
  gtk_widget_set_usize(y,50,0);
  sprintf(s,"%.2lf",gl.y);
  gtk_entry_set_text(GTK_ENTRY(y), s);
  gtk_box_pack_start(GTK_BOX(hbox), y, FALSE, FALSE, 5);
  gtk_widget_show(y);
  dummy=gtk_label_new("Z:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,5);
  gtk_widget_show(dummy);
  gl.wz=z=gtk_entry_new_with_max_length(10);
  gtk_widget_set_usize(z,50,0);
  sprintf(s,"%.2lf",gl.z);
  gtk_entry_set_text(GTK_ENTRY(z), s);
  gtk_box_pack_start(GTK_BOX(hbox), z, FALSE, FALSE, 5);
  gtk_widget_show(z);
  off=gtk_check_button_new_with_label("Off");
  gtk_box_pack_end(GTK_BOX(hbox),off,FALSE,FALSE,0);
  gtk_widget_show(off);
  gtk_widget_show(hbox);
  /* Signals */

  gtk_signal_connect (GTK_OBJECT (x), "activate",
	    GTK_SIGNAL_FUNC (ChangeEye), (gpointer)0);
  gtk_signal_connect (GTK_OBJECT (y), "activate",
	    GTK_SIGNAL_FUNC (ChangeEye), (gpointer)1);
  gtk_signal_connect (GTK_OBJECT (z), "activate",
	    GTK_SIGNAL_FUNC (ChangeEye), (gpointer)2);
  gtk_signal_connect (GTK_OBJECT (off), "toggled",
	    GTK_SIGNAL_FUNC (FrameOff), (gpointer)frame);
  gtk_widget_show(vbox);
}

/* Orientation frame */
void CreateOrientFrameItems(GtkWidget *frame)
{
  GtkWidget *vbox;		/* vbox for a little space */
  GtkWidget *hbox;		/* hbox for eye position */
  GtkWidget *dummy;		/* dummy widget for labels */
  GtkWidget *x,*y,*z;		/* widgets for coordinates */
  GtkWidget *off;		/* switch frame off button */
  char s[14];			/* string for frameskip */

  vbox = gtk_vbox_new(FALSE, 3);
  gtk_container_add(GTK_CONTAINER(frame),vbox);
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,3);
  dummy=gtk_label_new("X:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,5);
  gtk_widget_show(dummy);
  gl.wphix=x=gtk_entry_new_with_max_length(10);
  gtk_widget_set_usize(x,50,0);
  sprintf(s,"%.2lf",gl.phix);
  gtk_entry_set_text(GTK_ENTRY(x), s);
  gtk_box_pack_start(GTK_BOX(hbox), x, FALSE, FALSE, 5);
  gtk_widget_show(x);
  dummy=gtk_label_new("Y:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,5);
  gtk_widget_show(dummy);
  gl.wphiy=y=gtk_entry_new_with_max_length(10);
  gtk_widget_set_usize(y,50,0);
  sprintf(s,"%.2lf",gl.phiy);
  gtk_entry_set_text(GTK_ENTRY(y), s);
  gtk_box_pack_start(GTK_BOX(hbox), y, FALSE, FALSE, 5);
  gtk_widget_show(y);
  dummy=gtk_label_new("Z:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,5);
  gtk_widget_show(dummy);
  gl.wphiz=z=gtk_entry_new_with_max_length(10);
  gtk_widget_set_usize(z,50,0);
  sprintf(s,"%.2lf",gl.phiz);
  gtk_entry_set_text(GTK_ENTRY(z), s);
  gtk_box_pack_start(GTK_BOX(hbox), z, FALSE, FALSE, 5);
  gtk_widget_show(z);
  off=gtk_check_button_new_with_label("Off");
  gtk_box_pack_end(GTK_BOX(hbox),off,FALSE,FALSE,0);
  gtk_widget_show(off);
  gtk_widget_show(hbox);
  /* Signals */

  gtk_signal_connect (GTK_OBJECT (x), "activate",
	    GTK_SIGNAL_FUNC (ChangeOrient), (gpointer)0);
  gtk_signal_connect (GTK_OBJECT (y), "activate",
	    GTK_SIGNAL_FUNC (ChangeOrient), (gpointer)1);
  gtk_signal_connect (GTK_OBJECT (z), "activate",
	    GTK_SIGNAL_FUNC (ChangeOrient), (gpointer)2);
  gtk_signal_connect (GTK_OBJECT (off), "toggled",
	    GTK_SIGNAL_FUNC (FrameOff), (gpointer)frame);
  gtk_widget_show(vbox);
}

void ChangeBG(GtkWidget *widget,gpointer data)
{
  int a;
  double val;

  a=(int)data;
  val=atof(gtk_entry_get_text(GTK_ENTRY(widget)));
  gl.bg[a]=val;
  if (!anim.running) Replot_Objects(0);
  RedrawTex();
}

void CreateBGFrameItems(GtkWidget *frame)
{
  GtkWidget *vbox;		/* vbox for a little space */
  GtkWidget *hbox;		/* hbox for colors */
  GtkWidget *dummy;		/* dummy widget for labels */
  GtkWidget *r,*g,*b,*a;	/* widgets for colors */
  GtkWidget *off;		/* switch frame off button */
  char s[14];			/* string for frameskip */

  vbox = gtk_hbox_new(FALSE, 3);
  gtk_container_add(GTK_CONTAINER(frame),vbox);
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  dummy=gtk_label_new("Red:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  r=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(r,36,0);
  sprintf(s,"%.2lf",gl.bg[0]);
  gtk_entry_set_text(GTK_ENTRY(r), s);
  gtk_box_pack_start(GTK_BOX(hbox), r, FALSE, FALSE, 3);
  gtk_widget_show(r);
  dummy=gtk_label_new("Green:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  g=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(g,36,0);
  sprintf(s,"%.2lf",gl.bg[1]);
  gtk_entry_set_text(GTK_ENTRY(g), s);
  gtk_box_pack_start(GTK_BOX(hbox), g, FALSE, FALSE, 3);
  gtk_widget_show(g);
  dummy=gtk_label_new("Blue:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  b=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(b,36,0);
  sprintf(s,"%.2lf",gl.bg[1]);
  gtk_entry_set_text(GTK_ENTRY(b), s);
  gtk_box_pack_start(GTK_BOX(hbox), b, FALSE, FALSE, 3);
  gtk_widget_show(b);
  dummy=gtk_label_new("Alpha:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  a=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(a,36,0);
  sprintf(s,"%.2lf",gl.bg[1]);
  gtk_entry_set_text(GTK_ENTRY(a), s);
  gtk_box_pack_start(GTK_BOX(hbox), a, FALSE, FALSE, 3);
  gtk_widget_show(a);
  off=gtk_check_button_new_with_label("Off");
  gtk_box_pack_end(GTK_BOX(hbox),off,FALSE,FALSE,0);
  gtk_widget_show(off);
  gtk_widget_show(hbox);
  /* Signals */

  gtk_signal_connect (GTK_OBJECT (r), "activate",
	    GTK_SIGNAL_FUNC (ChangeBG), (gpointer)0);
  gtk_signal_connect (GTK_OBJECT (g), "activate",
	    GTK_SIGNAL_FUNC (ChangeBG), (gpointer)1);
  gtk_signal_connect (GTK_OBJECT (b), "activate",
	    GTK_SIGNAL_FUNC (ChangeBG), (gpointer)2);
  gtk_signal_connect (GTK_OBJECT (a), "activate",
	    GTK_SIGNAL_FUNC (ChangeBG), (gpointer)3);
  gtk_signal_connect (GTK_OBJECT (off), "toggled",
	    GTK_SIGNAL_FUNC (FrameOff), (gpointer)frame);
  gtk_widget_show(vbox);
}

/* EOF */
