/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2003/05/06 14:04:58 $ $Revision: 1.3 $ */

#ifndef IO_H
#define IO_H

typedef struct iostr_ {
  FILE *in;			/* stream */
  int filetype;			/* datafile type 0 normal/1 compressed */
  FILE *(*open) (const char *,const char *);
  int (*close) (FILE *);
  int (*scan) (char *,void *);
  int (*getline) (FILE *);
  int (*print) (FILE *,const char *,...);
  long (*tell) (FILE *);
  long (*read) (FILE *,long);
  int (*seek) (FILE *,long,int);
  void (*rewind) (FILE *);
  int (*eof) (FILE *);
  char *buff;
  int bp;
  int linelen;
  char *filename;
} iostr;

iostr io;

#endif
