/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2003/12/02 12:43:23 $ $Revision: 1.3 $ */

#ifndef MOVIE_H
#define MOVIE_H

#include "rpn.h"

#define NFRV 8
#define SL 1000
#define NHBOX 18
#define NENTR 16

typedef struct MOVIE_ {
  int savesnapisup;		/* save snapshot window is up */
  int savesnapdialup;		/* save snapshot dialog window is up */
  GtkWidget *savesnapwin;	/* save snapshot window */
  int paramwindowisup;		/* movie param window is up */
  GtkWidget *parammoviewindow;	/* movie param window */
  GtkWidget *entry[NENTR];	/* not always a text widget... */
  char *tmpdir;			/* tmpdir where the image files will be put */
  char *outfile;		/* output filename */
  char *pattern;		/* IBP pattern */
  int framerate;		/* framereate index */
  int framerepeat;		/* framerepeat */
  int quadres;			/* resolution of the quad objects */
  char *dx,*dy,*dz;		/* origin shift */
  char *rx,*ry,*rz;		/* rotation change */
  RPN *rdx,*rdy,*rdz;		/* RPN of origin shift */
  RPN *rrx,*rry,*rrz;		/* RPN of rotation change */
  int width,height;		/* size of the screen */
  int quality;			/* quality of the movie */
  double RPN_vars[7];		/* variables for origin change */
} MOVIE;

MOVIE movie;

#endif
