  /* This code calculates the cylinder properties of a force chain
   * connecting two points. Not tested! */
  if (body[a].type==BT_Force) { /* Force has to be calculated */
    /* position */
    body[a].x=body[body[a].ind1].x;
    body[a].y=body[body[a].ind1].y;
    body[a].z=body[body[a].ind1].z;
    /* ind1->ind2 vector */
    nx=body[body[a].ind2].x-body[a].x;
    ny=body[body[a].ind2].y-body[a].y;
    nz=body[body[a].ind2].z-body[a].z;
    /* normalization */
    r=sqrt(nx*nx+ny*ny+nz*nz);
    nx/=r;ny/=r;nz/=r;
    /* vector product */
    r=nx;nx=-ny;ny=r;nz=0.0;
    /* calculating phi */
    body[a].phi=asin(sqrt(nx*nx+ny*ny))/M_PI*180.0;
  }

void ChangeColor(GtkWidget *widget, gpointer data)
{
  int a;
  double val;

  a=(int)data;
  val=atof(gtk_entry_get_text(GTK_ENTRY(widget)));
  switch (a) {
    case 0:
      animation.r=val;
      break;
    case 1:
      animation.g=val;
      break;
    case 2:
      animation.b=val;
      break;
    case 3:
      animation.a=val;
      break;
  }
  if (!anim.running) Replot_Objects(0);
}

/* Textureless color frame */
void CreateTexturelessColorItems(GtkWidget *frame)
{
  GtkWidget *vbox;		/* vbox for a little space */
  GtkWidget *hbox;		/* hbox for colors */
  GtkWidget *dummy;		/* dummy widget for labels */
  GtkWidget *r,*g,*b,*a;	/* widgets for colors */
  GtkWidget *off;		/* switch frame off button */
  char s[8];			/* string for frameskip */

  vbox = gtk_hbox_new(FALSE, 3);
  gtk_container_add(GTK_CONTAINER(frame),vbox);
  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,0);
  dummy=gtk_label_new("Red:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  r=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(r,30,0);
  sprintf(s,"%.2lf",animation.r);
  gtk_entry_set_text(GTK_ENTRY(r), s);
  gtk_box_pack_start(GTK_BOX(hbox), r, FALSE, FALSE, 3);
  gtk_widget_show(r);
  dummy=gtk_label_new("Green:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  g=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(g,30,0);
  sprintf(s,"%.2lf",animation.g);
  gtk_entry_set_text(GTK_ENTRY(g), s);
  gtk_box_pack_start(GTK_BOX(hbox), g, FALSE, FALSE, 3);
  gtk_widget_show(g);
  dummy=gtk_label_new("Blue:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  b=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(b,30,0);
  sprintf(s,"%.2lf",animation.b);
  gtk_entry_set_text(GTK_ENTRY(b), s);
  gtk_box_pack_start(GTK_BOX(hbox), b, FALSE, FALSE, 3);
  gtk_widget_show(b);
  dummy=gtk_label_new("Alpha:");
  gtk_box_pack_start(GTK_BOX(hbox),dummy,FALSE,FALSE,3);
  gtk_widget_show(dummy);
  a=gtk_entry_new_with_max_length(4);
  gtk_widget_set_usize(a,30,0);
  sprintf(s,"%.2lf",animation.a);
  gtk_entry_set_text(GTK_ENTRY(a), s);
  gtk_box_pack_start(GTK_BOX(hbox), a, FALSE, FALSE, 3);
  gtk_widget_show(a);
  off=gtk_check_button_new_with_label("Off");
  gtk_box_pack_end(GTK_BOX(hbox),off,FALSE,FALSE,0);
  gtk_widget_show(off);
  gtk_widget_show(hbox);
  /* Signals */

  gtk_signal_connect (GTK_OBJECT (r), "activate",
	    GTK_SIGNAL_FUNC (ChangeColor), (gpointer)0);
  gtk_signal_connect (GTK_OBJECT (g), "activate",
	    GTK_SIGNAL_FUNC (ChangeColor), (gpointer)1);
  gtk_signal_connect (GTK_OBJECT (b), "activate",
	    GTK_SIGNAL_FUNC (ChangeColor), (gpointer)2);
  gtk_signal_connect (GTK_OBJECT (a), "activate",
	    GTK_SIGNAL_FUNC (ChangeColor), (gpointer)3);
  gtk_signal_connect (GTK_OBJECT (off), "toggled",
	    GTK_SIGNAL_FUNC (FrameOff), (gpointer)frame);
  gtk_widget_show(vbox);
}

/* These settings are valid for all objects */
void Set_General(BODY *body)
{

  if (body->appearance&BA_Texture2D) {
    glBindTexture(GL_TEXTURE_2D,gl.texture.texture[body->texture]);
    glEnable(GL_TEXTURE_2D);
  } else glDisable(GL_TEXTURE_2D);

  if (body->appearance&BA_Texture1D) {
    glBindTexture(GL_TEXTURE_1D,gl.texture.texture[body->texture]);
    glEnable(GL_TEXTURE_1D);
  } else glDisable(GL_TEXTURE_1D);

  if (body->appearance&BA_Color) {
    glColorMaterial(GL_FRONT_AND_BACK, body->material);
    glEnable(GL_COLOR_MATERIAL);
  } else glDisable(GL_COLOR_MATERIAL);

  if (body->appearance&BA_Blend) {
    glEnable(GL_BLEND);
  } else glDisable(GL_BLEND);

  glLoadIdentity();
  glTranslatef(gl.x, gl.z,gl.y);
  glRotatef(gl.phiy,0.0,0.0,1.0);
  glRotatef(gl.phiz,0.0,1.0,0.0);
  glRotatef(gl.phix,1.0,0.0,0.0);
  glTranslatef(gl.f*body->x, gl.f*body->z,gl.f*body->y);
  glRotatef(-body->phi*180/M_PI,body->rx,body->rz,body->ry);
  glColor4f(body->color[0],body->color[1],body->color[2],body->color[3]);

}
