/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2003/12/02 12:43:23 $ $Revision: 1.7 $ */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#ifndef RPN_H
#define RPN_H

#define RpnT_Const	1
#define RpnT_Var	2
#define RpnT_Unary	3
#define RpnT_Binary	4

typedef struct RPN_ {
  int rpn;		/* 1 if already converted */
  int type;		/* see RpnT_... */
  int rank;		/* rank in resolve order */
  double dval;		/* floating point value */
  int ival;		/* integer value */
  struct RPN_ *next;	/* next eleement */
} RPN;

RPN *rpnroot;
#define RPN_UONum	15
#define CEF_PARNUM	12	/* number of parameter types */
#define CEF_SUBPARNUM	5	/* number of subparameters */

extern const char RPN_openbracket[4];
extern const char RPN_closebracket[4];
extern const char RPN_binaryoperator[20];
extern const char RPN_unaryoperator[RPN_UONum][5];
extern const char RPN_number[12];
extern const char RPN_sign[3];
extern const char cef_parstr[CEF_PARNUM][CEF_SUBPARNUM][4];

#define RpnVT_Constr	1
#define RpnVT_Time	2

#endif

